 #include "reg52.h"
 #include "intrins.h"

 #define uchar unsigned char
 #define uint unsigned int
 #define somenop {_nop_();_nop_();_nop_();_nop_();_nop_();_nop_();_nop_();_nop_();_nop_();_nop_();}
 
  sbit TX=P1^0;
  sbit RX=P1^1;
 
 
 
 uchar code tab[]={0xc0,0xf9,0xa4,0xb0,0x99,0x92,0x82,0xf8,0x80,0x90,0xbf,0xff};
 uchar t=0;
 uchar flag=0;
 uint tim;
 uint distance;
 uchar yi,er,san,si,wu,liu,qi,ba;
 void display12(uchar z,uchar x);
 void display34(uchar z,uchar x);
 void display56(uchar z,uchar x);
 void display78(uchar z,uchar x);
 void sendwave(void);


 void Delay1ms(void);
 void allinit()
 {
 	P2=0XA0;
	P0=0X00;
	P2&=0X1F;

	P2=0X80;
	P0=0XFF;
	P2&=0X1F;

	P2=0XC0;
	P0=0XFF;
	P2&=0X1F;

	P2=0XFF;
	P0=0XFF;
 	P2&=0X1F;
 }





 void main()
 {
 	allinit();

	TMOD=0X11;
	TH0=(65536-2000)/256;
	TL0=(65536-2000)%256;
	TH1=0;
	TL1=0;
	EA=1;
	ET0=1;
	TR0=1;



	while(1)
	{
//		if(flag==1)
//		{
//			flag=0;
//			
//		}

		liu=distance/100;qi=distance%100/10;ba=distance%10;
				  
		 display12(yi,er);
		 display34(san,si);
		 display56(wu,liu);
		 display78(qi,ba);

	}
 
 }



  void it_t0() interrupt 1
  {
  	TH0=(65536-2000)/256;
	TL0=(65536-2000)%256;
	t++;	
  	if(t==100)//200ms
	{
			TR0=0;
			sendwave();
			TR1=1;
			while((RX==1)&&(TF1==0));	  //رע⣺RX==1;֮ǰд
			TR1=0;
			if(TF1==1)
			{
			
				TF1=0;
				distance=999; 
				
			}	
			 else
			 {
			 
			 tim=((TH1<<8)|TL1);
			 distance=tim*0.017;
//			 RX=1;
			 }
			 TR0=1;
			TH1=0;TL1=0;
			t=0;	
	
	}
  }

  void sendwave(void)
  {
  	 TX=1;
	 somenop;
	 TX=0;
  	 somenop;
  } 


void Delay1ms()		//@11.0592MHz
{
	unsigned char i, j;

	_nop_();
	_nop_();
	_nop_();
	i = 11;
	j = 190;
	do
	{
		while (--j);
	} while (--i);
}
				 
   void display12(uchar z,uchar x)
   {
   	P2=0XC0;
	P0=0X01;
	P2&=0X1F;

	P2=0XFF;
	P0=tab[z];
   	P2&=0X1F;
    Delay1ms();

	P2=0XC0;
	P0=0X02;
	P2&=0X1F;

	P2=0XFF;
	P0=tab[x];
   	P2&=0X1F;
	Delay1ms();
   }

   void display34(uchar z,uchar x)
   {
   	P2=0XC0;
	P0=0X04;
	P2&=0X1F;

	P2=0XFF;
	P0=tab[z];
   	P2&=0X1F;
    Delay1ms();

	P2=0XC0;
	P0=0X08;
	P2&=0X1F;

	P2=0XFF;
	P0=tab[x];
   	P2&=0X1F;
	Delay1ms();
   }

   void display56(uchar z,uchar x)
   {
   	P2=0XC0;
	P0=0X10;
	P2&=0X1F;

	P2=0XFF;
	P0=tab[z];
   	P2&=0X1F;
    Delay1ms();

	P2=0XC0;
	P0=0X20;
	P2&=0X1F;

	P2=0XFF;
	P0=tab[x];
   	P2&=0X1F;
	Delay1ms();
   }

	void display78(uchar z,uchar x)
   {
   	P2=0XC0;
	P0=0X40;
	P2&=0X1F;

	P2=0XFF;
	P0=tab[z];
   	P2&=0X1F;
    Delay1ms();

	P2=0XC0;
	P0=0X80;
	P2&=0X1F;

	P2=0XFF;
	P0=tab[x];
   	P2&=0X1F;
	Delay1ms();
   }





